//+---------------------------------------------------+
//|                                NLD_MedBuffers.mq5 |
//|                             http://www.nelodi.com |
//|                     Copyright (c) 2019 NELODI.com |
//+---------------------------------------------------+

#include "NLD_Colors.mqh"

#define MAX_WAVE_LEN 30
#define MAX_SHIFT_LEN 1000

int ExtShift[MAX_SHIFT_LEN+2];
int ExtShiftP;

//---- indicator buffer
double        ExtMColorBuffer00f[];
double        ExtMColorBuffer01f[];
double        ExtMColorBuffer02f[];
double        ExtMColorBuffer03f[];
double        ExtMColorBuffer04f[];
double        ExtMColorBuffer05f[];
double        ExtMColorBuffer06f[];
double        ExtMColorBuffer07f[];
double        ExtMColorBuffer08f[];
double        ExtMColorBuffer09f[];
double        ExtMLBuffer00f[];
double        ExtMLBuffer01f[];
double        ExtMLBuffer02f[];
double        ExtMLBuffer03f[];
double        ExtMLBuffer04f[];
double        ExtMLBuffer05f[];
double        ExtMLBuffer06f[];
double        ExtMLBuffer07f[];
double        ExtMLBuffer08f[];
double        ExtMLBuffer09f[];
double        ExtMColorBuffer00m[];
double        ExtMColorBuffer01m[];
double        ExtMColorBuffer02m[];
double        ExtMColorBuffer03m[];
double        ExtMColorBuffer04m[];
double        ExtMColorBuffer05m[];
double        ExtMColorBuffer06m[];
double        ExtMColorBuffer07m[];
double        ExtMColorBuffer08m[];
double        ExtMColorBuffer09m[];
double        ExtMLBuffer00m[];
double        ExtMLBuffer01m[];
double        ExtMLBuffer02m[];
double        ExtMLBuffer03m[];
double        ExtMLBuffer04m[];
double        ExtMLBuffer05m[];
double        ExtMLBuffer06m[];
double        ExtMLBuffer07m[];
double        ExtMLBuffer08m[];
double        ExtMLBuffer09m[];
double        ExtMColorBuffer00s[];
double        ExtMColorBuffer01s[];
double        ExtMColorBuffer02s[];
double        ExtMColorBuffer03s[];
double        ExtMColorBuffer04s[];
double        ExtMColorBuffer05s[];
double        ExtMColorBuffer06s[];
double        ExtMColorBuffer07s[];
double        ExtMColorBuffer08s[];
double        ExtMColorBuffer09s[];
double        ExtMLBuffer00s[];
double        ExtMLBuffer01s[];
double        ExtMLBuffer02s[];
double        ExtMLBuffer03s[];
double        ExtMLBuffer04s[];
double        ExtMLBuffer05s[];
double        ExtMLBuffer06s[];
double        ExtMLBuffer07s[];
double        ExtMLBuffer08s[];
double        ExtMLBuffer09s[];

double        ExtMColorBuffer10f[];
double        ExtMColorBuffer11f[];
double        ExtMColorBuffer12f[];
double        ExtMColorBuffer13f[];
double        ExtMColorBuffer14f[];
double        ExtMColorBuffer15f[];
double        ExtMColorBuffer16f[];
double        ExtMColorBuffer17f[];
double        ExtMColorBuffer18f[];
double        ExtMColorBuffer19f[];
double        ExtMLBuffer10f[];
double        ExtMLBuffer11f[];
double        ExtMLBuffer12f[];
double        ExtMLBuffer13f[];
double        ExtMLBuffer14f[];
double        ExtMLBuffer15f[];
double        ExtMLBuffer16f[];
double        ExtMLBuffer17f[];
double        ExtMLBuffer18f[];
double        ExtMLBuffer19f[];
double        ExtMColorBuffer10m[];
double        ExtMColorBuffer11m[];
double        ExtMColorBuffer12m[];
double        ExtMColorBuffer13m[];
double        ExtMColorBuffer14m[];
double        ExtMColorBuffer15m[];
double        ExtMColorBuffer16m[];
double        ExtMColorBuffer17m[];
double        ExtMColorBuffer18m[];
double        ExtMColorBuffer19m[];
double        ExtMLBuffer10m[];
double        ExtMLBuffer11m[];
double        ExtMLBuffer12m[];
double        ExtMLBuffer13m[];
double        ExtMLBuffer14m[];
double        ExtMLBuffer15m[];
double        ExtMLBuffer16m[];
double        ExtMLBuffer17m[];
double        ExtMLBuffer18m[];
double        ExtMLBuffer19m[];
double        ExtMColorBuffer10s[];
double        ExtMColorBuffer11s[];
double        ExtMColorBuffer12s[];
double        ExtMColorBuffer13s[];
double        ExtMColorBuffer14s[];
double        ExtMColorBuffer15s[];
double        ExtMColorBuffer16s[];
double        ExtMColorBuffer17s[];
double        ExtMColorBuffer18s[];
double        ExtMColorBuffer19s[];
double        ExtMLBuffer10s[];
double        ExtMLBuffer11s[];
double        ExtMLBuffer12s[];
double        ExtMLBuffer13s[];
double        ExtMLBuffer14s[];
double        ExtMLBuffer15s[];
double        ExtMLBuffer16s[];
double        ExtMLBuffer17s[];
double        ExtMLBuffer18s[];
double        ExtMLBuffer19s[];

double        ExtMColorBuffer20f[];
double        ExtMColorBuffer21f[];
double        ExtMColorBuffer22f[];
double        ExtMColorBuffer23f[];
double        ExtMColorBuffer24f[];
double        ExtMColorBuffer25f[];
double        ExtMColorBuffer26f[];
double        ExtMColorBuffer27f[];
double        ExtMColorBuffer28f[];
double        ExtMColorBuffer29f[];
double        ExtMLBuffer20f[];
double        ExtMLBuffer21f[];
double        ExtMLBuffer22f[];
double        ExtMLBuffer23f[];
double        ExtMLBuffer24f[];
double        ExtMLBuffer25f[];
double        ExtMLBuffer26f[];
double        ExtMLBuffer27f[];
double        ExtMLBuffer28f[];
double        ExtMLBuffer29f[];
double        ExtMColorBuffer20m[];
double        ExtMColorBuffer21m[];
double        ExtMColorBuffer22m[];
double        ExtMColorBuffer23m[];
double        ExtMColorBuffer24m[];
double        ExtMColorBuffer25m[];
double        ExtMColorBuffer26m[];
double        ExtMColorBuffer27m[];
double        ExtMColorBuffer28m[];
double        ExtMColorBuffer29m[];
double        ExtMLBuffer20m[];
double        ExtMLBuffer21m[];
double        ExtMLBuffer22m[];
double        ExtMLBuffer23m[];
double        ExtMLBuffer24m[];
double        ExtMLBuffer25m[];
double        ExtMLBuffer26m[];
double        ExtMLBuffer27m[];
double        ExtMLBuffer28m[];
double        ExtMLBuffer29m[];
double        ExtMColorBuffer20s[];
double        ExtMColorBuffer21s[];
double        ExtMColorBuffer22s[];
double        ExtMColorBuffer23s[];
double        ExtMColorBuffer24s[];
double        ExtMColorBuffer25s[];
double        ExtMColorBuffer26s[];
double        ExtMColorBuffer27s[];
double        ExtMColorBuffer28s[];
double        ExtMColorBuffer29s[];
double        ExtMLBuffer20s[];
double        ExtMLBuffer21s[];
double        ExtMLBuffer22s[];
double        ExtMLBuffer23s[];
double        ExtMLBuffer24s[];
double        ExtMLBuffer25s[];
double        ExtMLBuffer26s[];
double        ExtMLBuffer27s[];
double        ExtMLBuffer28s[];
double        ExtMLBuffer29s[];

//+------------------------------------------------------------------+
void MyArrClear(double &arr[],const double val)
  {
   int asize=ArraySize(arr);
   if(asize>0) ArrayFill(arr,0,asize,val);
  }
//+------------------------------------------------------------------+
void MyArrClear(int &arr[],const int val)
  {
   int asize=ArraySize(arr);
   if(asize>0) ArrayFill(arr,0,asize,val);
  }
//+------------------------------------------------------------------+
void MyArrCopy(double &arr[],int copyCount, int copyDistance)
   {
   int siz=ArraySize(arr),start=(copyCount>0?siz-copyCount:copyDistance); if(start<0) start=0;
   if(siz>0)
      {
      if(start>=copyDistance) ArrayCopy(arr,arr,start-copyDistance,start,copyCount);
      else if(start-(copyDistance-start)>0) ArrayCopy(arr,arr,0,start-(copyDistance-start),copyCount);
      }
   }
//+------------------------------------------------------------------+
void MyMBuff(const int l,const int k,const double v,const double c)
  {
   switch(l)
     {
      case  0: { ExtMLBuffer00m[k]=v;  ExtMColorBuffer00m[k]=c; break; }
      case  1: { ExtMLBuffer01m[k]=v;  ExtMColorBuffer01m[k]=c; break; }
      case  2: { ExtMLBuffer02m[k]=v;  ExtMColorBuffer02m[k]=c; break; }
      case  3: { ExtMLBuffer03m[k]=v;  ExtMColorBuffer03m[k]=c; break; }
      case  4: { ExtMLBuffer04m[k]=v;  ExtMColorBuffer04m[k]=c; break; }
      case  5: { ExtMLBuffer05m[k]=v;  ExtMColorBuffer05m[k]=c; break; }
      case  6: { ExtMLBuffer06m[k]=v;  ExtMColorBuffer06m[k]=c; break; }
      case  7: { ExtMLBuffer07m[k]=v;  ExtMColorBuffer07m[k]=c; break; }
      case  8: { ExtMLBuffer08m[k]=v;  ExtMColorBuffer08m[k]=c; break; }
      case  9: { ExtMLBuffer09m[k]=v;  ExtMColorBuffer09m[k]=c; break; }

      case 10: { ExtMLBuffer10m[k]=v;  ExtMColorBuffer10m[k]=c; break; }
      case 11: { ExtMLBuffer11m[k]=v;  ExtMColorBuffer11m[k]=c; break; }
      case 12: { ExtMLBuffer12m[k]=v;  ExtMColorBuffer12m[k]=c; break; }
      case 13: { ExtMLBuffer13m[k]=v;  ExtMColorBuffer13m[k]=c; break; }
      case 14: { ExtMLBuffer14m[k]=v;  ExtMColorBuffer14m[k]=c; break; }
      case 15: { ExtMLBuffer15m[k]=v;  ExtMColorBuffer15m[k]=c; break; }
      case 16: { ExtMLBuffer16m[k]=v;  ExtMColorBuffer16m[k]=c; break; }
      case 17: { ExtMLBuffer17m[k]=v;  ExtMColorBuffer17m[k]=c; break; }
      case 18: { ExtMLBuffer18m[k]=v;  ExtMColorBuffer18m[k]=c; break; }
      case 19: { ExtMLBuffer19m[k]=v;  ExtMColorBuffer19m[k]=c; break; }

      case 20: { ExtMLBuffer20m[k]=v;  ExtMColorBuffer20m[k]=c; break; }
      case 21: { ExtMLBuffer21m[k]=v;  ExtMColorBuffer21m[k]=c; break; }
      case 22: { ExtMLBuffer22m[k]=v;  ExtMColorBuffer22m[k]=c; break; }
      case 23: { ExtMLBuffer23m[k]=v;  ExtMColorBuffer23m[k]=c; break; }
      case 24: { ExtMLBuffer24m[k]=v;  ExtMColorBuffer24m[k]=c; break; }
      case 25: { ExtMLBuffer25m[k]=v;  ExtMColorBuffer25m[k]=c; break; }
      case 26: { ExtMLBuffer26m[k]=v;  ExtMColorBuffer26m[k]=c; break; }
      case 27: { ExtMLBuffer27m[k]=v;  ExtMColorBuffer27m[k]=c; break; }
      case 28: { ExtMLBuffer28m[k]=v;  ExtMColorBuffer28m[k]=c; break; }
      case 29: { ExtMLBuffer29m[k]=v;  ExtMColorBuffer29m[k]=c; break; }
     }
  }
//+------------------------------------------------------------------+
void MyFBuff(const int l,const int k,const double v,const double c)
  {
   switch(l)
     {
      case  0: { ExtMLBuffer00f[k]=v;  ExtMColorBuffer00f[k]=c; break; }
      case  1: { ExtMLBuffer01f[k]=v;  ExtMColorBuffer01f[k]=c; break; }
      case  2: { ExtMLBuffer02f[k]=v;  ExtMColorBuffer02f[k]=c; break; }
      case  3: { ExtMLBuffer03f[k]=v;  ExtMColorBuffer03f[k]=c; break; }
      case  4: { ExtMLBuffer04f[k]=v;  ExtMColorBuffer04f[k]=c; break; }
      case  5: { ExtMLBuffer05f[k]=v;  ExtMColorBuffer05f[k]=c; break; }
      case  6: { ExtMLBuffer06f[k]=v;  ExtMColorBuffer06f[k]=c; break; }
      case  7: { ExtMLBuffer07f[k]=v;  ExtMColorBuffer07f[k]=c; break; }
      case  8: { ExtMLBuffer08f[k]=v;  ExtMColorBuffer08f[k]=c; break; }
      case  9: { ExtMLBuffer09f[k]=v;  ExtMColorBuffer09f[k]=c; break; }

      case 10: { ExtMLBuffer10f[k]=v;  ExtMColorBuffer10f[k]=c; break; }
      case 11: { ExtMLBuffer11f[k]=v;  ExtMColorBuffer11f[k]=c; break; }
      case 12: { ExtMLBuffer12f[k]=v;  ExtMColorBuffer12f[k]=c; break; }
      case 13: { ExtMLBuffer13f[k]=v;  ExtMColorBuffer13f[k]=c; break; }
      case 14: { ExtMLBuffer14f[k]=v;  ExtMColorBuffer14f[k]=c; break; }
      case 15: { ExtMLBuffer15f[k]=v;  ExtMColorBuffer15f[k]=c; break; }
      case 16: { ExtMLBuffer16f[k]=v;  ExtMColorBuffer16f[k]=c; break; }
      case 17: { ExtMLBuffer17f[k]=v;  ExtMColorBuffer17f[k]=c; break; }
      case 18: { ExtMLBuffer18f[k]=v;  ExtMColorBuffer18f[k]=c; break; }
      case 19: { ExtMLBuffer19f[k]=v;  ExtMColorBuffer19f[k]=c; break; }

      case 20: { ExtMLBuffer20f[k]=v;  ExtMColorBuffer20f[k]=c; break; }
      case 21: { ExtMLBuffer21f[k]=v;  ExtMColorBuffer21f[k]=c; break; }
      case 22: { ExtMLBuffer22f[k]=v;  ExtMColorBuffer22f[k]=c; break; }
      case 23: { ExtMLBuffer23f[k]=v;  ExtMColorBuffer23f[k]=c; break; }
      case 24: { ExtMLBuffer24f[k]=v;  ExtMColorBuffer24f[k]=c; break; }
      case 25: { ExtMLBuffer25f[k]=v;  ExtMColorBuffer25f[k]=c; break; }
      case 26: { ExtMLBuffer26f[k]=v;  ExtMColorBuffer26f[k]=c; break; }
      case 27: { ExtMLBuffer27f[k]=v;  ExtMColorBuffer27f[k]=c; break; }
      case 28: { ExtMLBuffer28f[k]=v;  ExtMColorBuffer28f[k]=c; break; }
      case 29: { ExtMLBuffer29f[k]=v;  ExtMColorBuffer29f[k]=c; break; }
     }
  }
//+------------------------------------------------------------------+
void MySBuff(const int l,const int k,const double v,const double c)
  {
   switch(l)
     {
      case  0: { ExtMLBuffer00s[k]=v;  ExtMColorBuffer00s[k]=c; break; }
      case  1: { ExtMLBuffer01s[k]=v;  ExtMColorBuffer01s[k]=c; break; }
      case  2: { ExtMLBuffer02s[k]=v;  ExtMColorBuffer02s[k]=c; break; }
      case  3: { ExtMLBuffer03s[k]=v;  ExtMColorBuffer03s[k]=c; break; }
      case  4: { ExtMLBuffer04s[k]=v;  ExtMColorBuffer04s[k]=c; break; }
      case  5: { ExtMLBuffer05s[k]=v;  ExtMColorBuffer05s[k]=c; break; }
      case  6: { ExtMLBuffer06s[k]=v;  ExtMColorBuffer06s[k]=c; break; }
      case  7: { ExtMLBuffer07s[k]=v;  ExtMColorBuffer07s[k]=c; break; }
      case  8: { ExtMLBuffer08s[k]=v;  ExtMColorBuffer08s[k]=c; break; }
      case  9: { ExtMLBuffer09s[k]=v;  ExtMColorBuffer09s[k]=c; break; }

      case 10: { ExtMLBuffer10s[k]=v;  ExtMColorBuffer10s[k]=c; break; }
      case 11: { ExtMLBuffer11s[k]=v;  ExtMColorBuffer11s[k]=c; break; }
      case 12: { ExtMLBuffer12s[k]=v;  ExtMColorBuffer12s[k]=c; break; }
      case 13: { ExtMLBuffer13s[k]=v;  ExtMColorBuffer13s[k]=c; break; }
      case 14: { ExtMLBuffer14s[k]=v;  ExtMColorBuffer14s[k]=c; break; }
      case 15: { ExtMLBuffer15s[k]=v;  ExtMColorBuffer15s[k]=c; break; }
      case 16: { ExtMLBuffer16s[k]=v;  ExtMColorBuffer16s[k]=c; break; }
      case 17: { ExtMLBuffer17s[k]=v;  ExtMColorBuffer17s[k]=c; break; }
      case 18: { ExtMLBuffer18s[k]=v;  ExtMColorBuffer18s[k]=c; break; }
      case 19: { ExtMLBuffer19s[k]=v;  ExtMColorBuffer19s[k]=c; break; }

      case 20: { ExtMLBuffer20s[k]=v;  ExtMColorBuffer20s[k]=c; break; }
      case 21: { ExtMLBuffer21s[k]=v;  ExtMColorBuffer21s[k]=c; break; }
      case 22: { ExtMLBuffer22s[k]=v;  ExtMColorBuffer22s[k]=c; break; }
      case 23: { ExtMLBuffer23s[k]=v;  ExtMColorBuffer23s[k]=c; break; }
      case 24: { ExtMLBuffer24s[k]=v;  ExtMColorBuffer24s[k]=c; break; }
      case 25: { ExtMLBuffer25s[k]=v;  ExtMColorBuffer25s[k]=c; break; }
      case 26: { ExtMLBuffer26s[k]=v;  ExtMColorBuffer26s[k]=c; break; }
      case 27: { ExtMLBuffer27s[k]=v;  ExtMColorBuffer27s[k]=c; break; }
      case 28: { ExtMLBuffer28s[k]=v;  ExtMColorBuffer28s[k]=c; break; }
      case 29: { ExtMLBuffer29s[k]=v;  ExtMColorBuffer29s[k]=c; break; }
     }
  }
//+------------------------------------------------------------------+
void MyPrepSMFBuffers(const int lFrom,
                      const int lTo,
                      int &x,int &z,
                      const int sC,const int mC,const int fC,
                      const int ssty,const int msty,const int fsty,
                      const int swid,const int mwid,const int fwid,
                      const int sicn,const int micn,const int ficn,
                      const bool iS,const bool iM,const bool iF,
                      const string sstr="s",const string mstr="m",const string fstr="f",
                      const double no_value=0)
  {
   if(lFrom<=30 && lTo>=30)
     {
      if(iS) MySetBuf(x,z,29,ExtMLBuffer29s,ExtMColorBuffer29s,sC,ssty,swid,sicn,sstr+"29",no_value);
      if(iF) MySetBuf(x,z,29,ExtMLBuffer29f,ExtMColorBuffer29f,fC,fsty,fwid,ficn,fstr+"29",no_value);
      if(iM) MySetBuf(x,z,29,ExtMLBuffer29m,ExtMColorBuffer29m,mC,msty,mwid,micn,mstr+"29",no_value);
     }
   if(lFrom<=29 && lTo>=29)
     {
      if(iS) MySetBuf(x,z,28,ExtMLBuffer28s,ExtMColorBuffer28s,sC,ssty,swid,sicn,sstr+"28",no_value);
      if(iF) MySetBuf(x,z,28,ExtMLBuffer28f,ExtMColorBuffer28f,fC,fsty,fwid,ficn,fstr+"28",no_value);
      if(iM) MySetBuf(x,z,28,ExtMLBuffer28m,ExtMColorBuffer28m,mC,msty,mwid,micn,mstr+"28",no_value);
     }
   if(lFrom<=28 && lTo>=28)
     {
      if(iS) MySetBuf(x,z,27,ExtMLBuffer27s,ExtMColorBuffer27s,sC,ssty,swid,sicn,sstr+"27",no_value);
      if(iF) MySetBuf(x,z,27,ExtMLBuffer27f,ExtMColorBuffer27f,fC,fsty,fwid,ficn,fstr+"27",no_value);
      if(iM) MySetBuf(x,z,27,ExtMLBuffer27m,ExtMColorBuffer27m,mC,msty,mwid,micn,mstr+"27",no_value);
     }
   if(lFrom<=27 && lTo>=27)
     {
      if(iS) MySetBuf(x,z,26,ExtMLBuffer26s,ExtMColorBuffer26s,sC,ssty,swid,sicn,sstr+"26",no_value);
      if(iF) MySetBuf(x,z,26,ExtMLBuffer26f,ExtMColorBuffer26f,fC,fsty,fwid,ficn,fstr+"26",no_value);
      if(iM) MySetBuf(x,z,26,ExtMLBuffer26m,ExtMColorBuffer26m,mC,msty,mwid,micn,mstr+"26",no_value);
     }
   if(lFrom<=26 && lTo>=26)
     {
      if(iS) MySetBuf(x,z,25,ExtMLBuffer25s,ExtMColorBuffer25s,sC,ssty,swid,sicn,sstr+"25",no_value);
      if(iF) MySetBuf(x,z,25,ExtMLBuffer25f,ExtMColorBuffer25f,fC,fsty,fwid,ficn,fstr+"25",no_value);
      if(iM) MySetBuf(x,z,25,ExtMLBuffer25m,ExtMColorBuffer25m,mC,msty,mwid,micn,mstr+"25",no_value);
     }
   if(lFrom<=25 && lTo>=25)
     {
      if(iS) MySetBuf(x,z,24,ExtMLBuffer24s,ExtMColorBuffer24s,sC,ssty,swid,sicn,sstr+"24",no_value);
      if(iF) MySetBuf(x,z,24,ExtMLBuffer24f,ExtMColorBuffer24f,fC,fsty,fwid,ficn,fstr+"24",no_value);
      if(iM) MySetBuf(x,z,24,ExtMLBuffer24m,ExtMColorBuffer24m,mC,msty,mwid,micn,mstr+"24",no_value);
     }
   if(lFrom<=24 && lTo>=24)
     {
      if(iS) MySetBuf(x,z,23,ExtMLBuffer23s,ExtMColorBuffer23s,sC,ssty,swid,sicn,sstr+"23",no_value);
      if(iF) MySetBuf(x,z,23,ExtMLBuffer23f,ExtMColorBuffer23f,fC,fsty,fwid,ficn,fstr+"23",no_value);
      if(iM) MySetBuf(x,z,23,ExtMLBuffer23m,ExtMColorBuffer23m,mC,msty,mwid,micn,mstr+"23",no_value);
     }
   if(lFrom<=23 && lTo>=23)
     {
      if(iS) MySetBuf(x,z,22,ExtMLBuffer22s,ExtMColorBuffer22s,sC,ssty,swid,sicn,sstr+"22",no_value);
      if(iF) MySetBuf(x,z,22,ExtMLBuffer22f,ExtMColorBuffer22f,fC,fsty,fwid,ficn,fstr+"22",no_value);
      if(iM) MySetBuf(x,z,22,ExtMLBuffer22m,ExtMColorBuffer22m,mC,msty,mwid,micn,mstr+"22",no_value);
     }
   if(lFrom<=22 && lTo>=22)
     {
      if(iS) MySetBuf(x,z,21,ExtMLBuffer21s,ExtMColorBuffer21s,sC,ssty,swid,sicn,sstr+"21",no_value);
      if(iF) MySetBuf(x,z,21,ExtMLBuffer21f,ExtMColorBuffer21f,fC,fsty,fwid,ficn,fstr+"21",no_value);
      if(iM) MySetBuf(x,z,21,ExtMLBuffer21m,ExtMColorBuffer21m,mC,msty,mwid,micn,mstr+"21",no_value);
     }
   if(lFrom<=21 && lTo>=21)
     {
      if(iS) MySetBuf(x,z,20,ExtMLBuffer20s,ExtMColorBuffer20s,sC,ssty,swid,sicn,sstr+"20",no_value);
      if(iF) MySetBuf(x,z,20,ExtMLBuffer20f,ExtMColorBuffer20f,fC,fsty,fwid,ficn,fstr+"20",no_value);
      if(iM) MySetBuf(x,z,20,ExtMLBuffer20m,ExtMColorBuffer20m,mC,msty,mwid,micn,mstr+"20",no_value);
     }
   if(lFrom<=20 && lTo>=20)
     {
      if(iS) MySetBuf(x,z,19,ExtMLBuffer19s,ExtMColorBuffer19s,sC,ssty,swid,sicn,sstr+"19",no_value);
      if(iF) MySetBuf(x,z,19,ExtMLBuffer19f,ExtMColorBuffer19f,fC,fsty,fwid,ficn,fstr+"19",no_value);
      if(iM) MySetBuf(x,z,19,ExtMLBuffer19m,ExtMColorBuffer19m,mC,msty,mwid,micn,mstr+"19",no_value);
     }
   if(lFrom<=19 && lTo>=19)
     {
      if(iS) MySetBuf(x,z,18,ExtMLBuffer18s,ExtMColorBuffer18s,sC,ssty,swid,sicn,sstr+"18",no_value);
      if(iF) MySetBuf(x,z,18,ExtMLBuffer18f,ExtMColorBuffer18f,fC,fsty,fwid,ficn,fstr+"18",no_value);
      if(iM) MySetBuf(x,z,18,ExtMLBuffer18m,ExtMColorBuffer18m,mC,msty,mwid,micn,mstr+"18",no_value);
     }
   if(lFrom<=18 && lTo>=18)
     {
      if(iS) MySetBuf(x,z,17,ExtMLBuffer17s,ExtMColorBuffer17s,sC,ssty,swid,sicn,sstr+"17",no_value);
      if(iF) MySetBuf(x,z,17,ExtMLBuffer17f,ExtMColorBuffer17f,fC,fsty,fwid,ficn,fstr+"17",no_value);
      if(iM) MySetBuf(x,z,17,ExtMLBuffer17m,ExtMColorBuffer17m,mC,msty,mwid,micn,mstr+"17",no_value);
     }
   if(lFrom<=17 && lTo>=17)
     {
      if(iS) MySetBuf(x,z,16,ExtMLBuffer16s,ExtMColorBuffer16s,sC,ssty,swid,sicn,sstr+"16",no_value);
      if(iF) MySetBuf(x,z,16,ExtMLBuffer16f,ExtMColorBuffer16f,fC,fsty,fwid,ficn,fstr+"16",no_value);
      if(iM) MySetBuf(x,z,16,ExtMLBuffer16m,ExtMColorBuffer16m,mC,msty,mwid,micn,mstr+"16",no_value);
     }
   if(lFrom<=16 && lTo>=16)
     {
      if(iS) MySetBuf(x,z,15,ExtMLBuffer15s,ExtMColorBuffer15s,sC,ssty,swid,sicn,sstr+"15",no_value);
      if(iF) MySetBuf(x,z,15,ExtMLBuffer15f,ExtMColorBuffer15f,fC,fsty,fwid,ficn,fstr+"15",no_value);
      if(iM) MySetBuf(x,z,15,ExtMLBuffer15m,ExtMColorBuffer15m,mC,msty,mwid,micn,mstr+"15",no_value);
     }
   if(lFrom<=15 && lTo>=15)
     {
      if(iS) MySetBuf(x,z,14,ExtMLBuffer14s,ExtMColorBuffer14s,sC,ssty,swid,sicn,sstr+"14",no_value);
      if(iF) MySetBuf(x,z,14,ExtMLBuffer14f,ExtMColorBuffer14f,fC,fsty,fwid,ficn,fstr+"14",no_value);
      if(iM) MySetBuf(x,z,14,ExtMLBuffer14m,ExtMColorBuffer14m,mC,msty,mwid,micn,mstr+"14",no_value);
     }
   if(lFrom<=14 && lTo>=14)
     {
      if(iS) MySetBuf(x,z,13,ExtMLBuffer13s,ExtMColorBuffer13s,sC,ssty,swid,sicn,sstr+"13",no_value);
      if(iF) MySetBuf(x,z,13,ExtMLBuffer13f,ExtMColorBuffer13f,fC,fsty,fwid,ficn,fstr+"13",no_value);
      if(iM) MySetBuf(x,z,13,ExtMLBuffer13m,ExtMColorBuffer13m,mC,msty,mwid,micn,mstr+"13",no_value);
     }
   if(lFrom<=13 && lTo>=13)
     {
      if(iS) MySetBuf(x,z,12,ExtMLBuffer12s,ExtMColorBuffer12s,sC,ssty,swid,sicn,sstr+"12",no_value);
      if(iF) MySetBuf(x,z,12,ExtMLBuffer12f,ExtMColorBuffer12f,fC,fsty,fwid,ficn,fstr+"12",no_value);
      if(iM) MySetBuf(x,z,12,ExtMLBuffer12m,ExtMColorBuffer12m,mC,msty,mwid,micn,mstr+"12",no_value);
     }
   if(lFrom<=12 && lTo>=12)
     {
      if(iS) MySetBuf(x,z,11,ExtMLBuffer11s,ExtMColorBuffer11s,sC,ssty,swid,sicn,sstr+"11",no_value);
      if(iF) MySetBuf(x,z,11,ExtMLBuffer11f,ExtMColorBuffer11f,fC,fsty,fwid,ficn,fstr+"11",no_value);
      if(iM) MySetBuf(x,z,11,ExtMLBuffer11m,ExtMColorBuffer11m,mC,msty,mwid,micn,mstr+"11",no_value);
     }
   if(lFrom<=11 && lTo>=11)
     {
      if(iS) MySetBuf(x,z,10,ExtMLBuffer10s,ExtMColorBuffer10s,sC,ssty,swid,sicn,sstr+"10",no_value);
      if(iF) MySetBuf(x,z,10,ExtMLBuffer10f,ExtMColorBuffer10f,fC,fsty,fwid,ficn,fstr+"10",no_value);
      if(iM) MySetBuf(x,z,10,ExtMLBuffer10m,ExtMColorBuffer10m,mC,msty,mwid,micn,mstr+"10",no_value);
     }
   if(lFrom<=10 && lTo>=10)
     {
      if(iS) MySetBuf(x,z,9,ExtMLBuffer09s,ExtMColorBuffer09s,sC,ssty,swid,sicn,sstr+"09",no_value);
      if(iF) MySetBuf(x,z,9,ExtMLBuffer09f,ExtMColorBuffer09f,fC,fsty,fwid,ficn,fstr+"09",no_value);
      if(iM) MySetBuf(x,z,9,ExtMLBuffer09m,ExtMColorBuffer09m,mC,msty,mwid,micn,mstr+"09",no_value);
     }
   if(lFrom<=9 && lTo>=9)
     {
      if(iS) MySetBuf(x,z,8,ExtMLBuffer08s,ExtMColorBuffer08s,sC,ssty,swid,sicn,sstr+"08",no_value);
      if(iF) MySetBuf(x,z,8,ExtMLBuffer08f,ExtMColorBuffer08f,fC,fsty,fwid,ficn,fstr+"08",no_value);
      if(iM) MySetBuf(x,z,8,ExtMLBuffer08m,ExtMColorBuffer08m,mC,msty,mwid,micn,mstr+"08",no_value);
     }
   if(lFrom<=8 && lTo>=8)
     {
      if(iS) MySetBuf(x,z,7,ExtMLBuffer07s,ExtMColorBuffer07s,sC,ssty,swid,sicn,sstr+"07",no_value);
      if(iF) MySetBuf(x,z,7,ExtMLBuffer07f,ExtMColorBuffer07f,fC,fsty,fwid,ficn,fstr+"07",no_value);
      if(iM) MySetBuf(x,z,7,ExtMLBuffer07m,ExtMColorBuffer07m,mC,msty,mwid,micn,mstr+"07",no_value);
     }
   if(lFrom<=7 && lTo>=7)
     {
      if(iS) MySetBuf(x,z,6,ExtMLBuffer06s,ExtMColorBuffer06s,sC,ssty,swid,sicn,sstr+"06",no_value);
      if(iF) MySetBuf(x,z,6,ExtMLBuffer06f,ExtMColorBuffer06f,fC,fsty,fwid,ficn,fstr+"06",no_value);
      if(iM) MySetBuf(x,z,6,ExtMLBuffer06m,ExtMColorBuffer06m,mC,msty,mwid,micn,mstr+"06",no_value);
     }
   if(lFrom<=6 && lTo>=6)
     {
      if(iS) MySetBuf(x,z,5,ExtMLBuffer05s,ExtMColorBuffer05s,sC,ssty,swid,sicn,sstr+"05",no_value);
      if(iF) MySetBuf(x,z,5,ExtMLBuffer05f,ExtMColorBuffer05f,fC,fsty,fwid,ficn,fstr+"05",no_value);
      if(iM) MySetBuf(x,z,5,ExtMLBuffer05m,ExtMColorBuffer05m,mC,msty,mwid,micn,mstr+"05",no_value);
     }
   if(lFrom<=5 && lTo>=5)
     {
      if(iS) MySetBuf(x,z,4,ExtMLBuffer04s,ExtMColorBuffer04s,sC,ssty,swid,sicn,sstr+"04",no_value);
      if(iF) MySetBuf(x,z,4,ExtMLBuffer04f,ExtMColorBuffer04f,fC,fsty,fwid,ficn,fstr+"04",no_value);
      if(iM) MySetBuf(x,z,4,ExtMLBuffer04m,ExtMColorBuffer04m,mC,msty,mwid,micn,mstr+"04",no_value);
     }
   if(lFrom<=4 && lTo>=4)
     {
      if(iS) MySetBuf(x,z,3,ExtMLBuffer03s,ExtMColorBuffer03s,sC,ssty,swid,sicn,sstr+"03",no_value);
      if(iF) MySetBuf(x,z,3,ExtMLBuffer03f,ExtMColorBuffer03f,fC,fsty,fwid,ficn,fstr+"03",no_value);
      if(iM) MySetBuf(x,z,3,ExtMLBuffer03m,ExtMColorBuffer03m,mC,msty,mwid,micn,mstr+"03",no_value);
     }
   if(lFrom<=3 && lTo>=3)
     {
      if(iS) MySetBuf(x,z,2,ExtMLBuffer02s,ExtMColorBuffer02s,sC,ssty,swid,sicn,sstr+"02",no_value);
      if(iF) MySetBuf(x,z,2,ExtMLBuffer02f,ExtMColorBuffer02f,fC,fsty,fwid,ficn,fstr+"02",no_value);
      if(iM) MySetBuf(x,z,2,ExtMLBuffer02m,ExtMColorBuffer02m,mC,msty,mwid,micn,mstr+"02",no_value);
     }
   if(lFrom<=2 && lTo>=2)
     {
      if(iS) MySetBuf(x,z,1,ExtMLBuffer01s,ExtMColorBuffer01s,sC,ssty,swid,sicn,sstr+"01",no_value);
      if(iF) MySetBuf(x,z,1,ExtMLBuffer01f,ExtMColorBuffer01f,fC,fsty,fwid,ficn,fstr+"01",no_value);
      if(iM) MySetBuf(x,z,1,ExtMLBuffer01m,ExtMColorBuffer01m,mC,msty,mwid,micn,mstr+"01",no_value);
     }
   if(lFrom<=1 && lTo>=1)
     {
      if(iS) MySetBuf(x,z,0,ExtMLBuffer00s,ExtMColorBuffer00s,sC,ssty,swid,sicn,sstr+"00",no_value);
      if(iF) MySetBuf(x,z,0,ExtMLBuffer00f,ExtMColorBuffer00f,fC,fsty,fwid,ficn,fstr+"00",no_value);
      if(iM) MySetBuf(x,z,0,ExtMLBuffer00m,ExtMColorBuffer00m,mC,msty,mwid,micn,mstr+"00",no_value);
     }
  }
//+------------------------------------------------------------------+
void MyClearSMFBuffers(double no_value=0, double no_color=NO_COLOR)
  {
   MyArrClear(ExtMLBuffer29s,no_value); MyArrClear(ExtMColorBuffer29s,no_color);
   MyArrClear(ExtMLBuffer29m,no_value); MyArrClear(ExtMColorBuffer29m,no_color);
   MyArrClear(ExtMLBuffer29f,no_value); MyArrClear(ExtMColorBuffer29f,no_color);

   MyArrClear(ExtMLBuffer28s,no_value); MyArrClear(ExtMColorBuffer28s,no_color);
   MyArrClear(ExtMLBuffer28m,no_value); MyArrClear(ExtMColorBuffer28m,no_color);
   MyArrClear(ExtMLBuffer28f,no_value); MyArrClear(ExtMColorBuffer28f,no_color);

   MyArrClear(ExtMLBuffer27s,no_value); MyArrClear(ExtMColorBuffer27s,no_color);
   MyArrClear(ExtMLBuffer27m,no_value); MyArrClear(ExtMColorBuffer27m,no_color);
   MyArrClear(ExtMLBuffer27f,no_value); MyArrClear(ExtMColorBuffer27f,no_color);

   MyArrClear(ExtMLBuffer26s,no_value); MyArrClear(ExtMColorBuffer26s,no_color);
   MyArrClear(ExtMLBuffer26m,no_value); MyArrClear(ExtMColorBuffer26m,no_color);
   MyArrClear(ExtMLBuffer26f,no_value); MyArrClear(ExtMColorBuffer26f,no_color);

   MyArrClear(ExtMLBuffer25s,no_value); MyArrClear(ExtMColorBuffer25s,no_color);
   MyArrClear(ExtMLBuffer25m,no_value); MyArrClear(ExtMColorBuffer25m,no_color);
   MyArrClear(ExtMLBuffer25f,no_value); MyArrClear(ExtMColorBuffer25f,no_color);

   MyArrClear(ExtMLBuffer24s,no_value); MyArrClear(ExtMColorBuffer24s,no_color);
   MyArrClear(ExtMLBuffer24m,no_value); MyArrClear(ExtMColorBuffer24m,no_color);
   MyArrClear(ExtMLBuffer24f,no_value); MyArrClear(ExtMColorBuffer24f,no_color);

   MyArrClear(ExtMLBuffer23s,no_value); MyArrClear(ExtMColorBuffer23s,no_color);
   MyArrClear(ExtMLBuffer23m,no_value); MyArrClear(ExtMColorBuffer23m,no_color);
   MyArrClear(ExtMLBuffer23f,no_value); MyArrClear(ExtMColorBuffer23f,no_color);

   MyArrClear(ExtMLBuffer22s,no_value); MyArrClear(ExtMColorBuffer22s,no_color);
   MyArrClear(ExtMLBuffer22m,no_value); MyArrClear(ExtMColorBuffer22m,no_color);
   MyArrClear(ExtMLBuffer22f,no_value); MyArrClear(ExtMColorBuffer22f,no_color);

   MyArrClear(ExtMLBuffer21s,no_value); MyArrClear(ExtMColorBuffer21s,no_color);
   MyArrClear(ExtMLBuffer21m,no_value); MyArrClear(ExtMColorBuffer21m,no_color);
   MyArrClear(ExtMLBuffer21f,no_value); MyArrClear(ExtMColorBuffer21f,no_color);

   MyArrClear(ExtMLBuffer20s,no_value); MyArrClear(ExtMColorBuffer20s,no_color);
   MyArrClear(ExtMLBuffer20m,no_value); MyArrClear(ExtMColorBuffer20m,no_color);
   MyArrClear(ExtMLBuffer20f,no_value); MyArrClear(ExtMColorBuffer20f,no_color);

   MyArrClear(ExtMLBuffer19s,no_value); MyArrClear(ExtMColorBuffer19s,no_color);
   MyArrClear(ExtMLBuffer19m,no_value); MyArrClear(ExtMColorBuffer19m,no_color);
   MyArrClear(ExtMLBuffer19f,no_value); MyArrClear(ExtMColorBuffer19f,no_color);

   MyArrClear(ExtMLBuffer18s,no_value); MyArrClear(ExtMColorBuffer18s,no_color);
   MyArrClear(ExtMLBuffer18m,no_value); MyArrClear(ExtMColorBuffer18m,no_color);
   MyArrClear(ExtMLBuffer18f,no_value); MyArrClear(ExtMColorBuffer18f,no_color);

   MyArrClear(ExtMLBuffer17s,no_value); MyArrClear(ExtMColorBuffer17s,no_color);
   MyArrClear(ExtMLBuffer17m,no_value); MyArrClear(ExtMColorBuffer17m,no_color);
   MyArrClear(ExtMLBuffer17f,no_value); MyArrClear(ExtMColorBuffer17f,no_color);

   MyArrClear(ExtMLBuffer16s,no_value); MyArrClear(ExtMColorBuffer16s,no_color);
   MyArrClear(ExtMLBuffer16m,no_value); MyArrClear(ExtMColorBuffer16m,no_color);
   MyArrClear(ExtMLBuffer16f,no_value); MyArrClear(ExtMColorBuffer16f,no_color);

   MyArrClear(ExtMLBuffer15s,no_value); MyArrClear(ExtMColorBuffer15s,no_color);
   MyArrClear(ExtMLBuffer15m,no_value); MyArrClear(ExtMColorBuffer15m,no_color);
   MyArrClear(ExtMLBuffer15f,no_value); MyArrClear(ExtMColorBuffer15f,no_color);

   MyArrClear(ExtMLBuffer14s,no_value); MyArrClear(ExtMColorBuffer14s,no_color);
   MyArrClear(ExtMLBuffer14m,no_value); MyArrClear(ExtMColorBuffer14m,no_color);
   MyArrClear(ExtMLBuffer14f,no_value); MyArrClear(ExtMColorBuffer14f,no_color);

   MyArrClear(ExtMLBuffer13s,no_value); MyArrClear(ExtMColorBuffer13s,no_color);
   MyArrClear(ExtMLBuffer13m,no_value); MyArrClear(ExtMColorBuffer13m,no_color);
   MyArrClear(ExtMLBuffer13f,no_value); MyArrClear(ExtMColorBuffer13f,no_color);

   MyArrClear(ExtMLBuffer12s,no_value); MyArrClear(ExtMColorBuffer12s,no_color);
   MyArrClear(ExtMLBuffer12m,no_value); MyArrClear(ExtMColorBuffer12m,no_color);
   MyArrClear(ExtMLBuffer12f,no_value); MyArrClear(ExtMColorBuffer12f,no_color);

   MyArrClear(ExtMLBuffer11s,no_value); MyArrClear(ExtMColorBuffer11s,no_color);
   MyArrClear(ExtMLBuffer11m,no_value); MyArrClear(ExtMColorBuffer11m,no_color);
   MyArrClear(ExtMLBuffer11f,no_value); MyArrClear(ExtMColorBuffer11f,no_color);

   MyArrClear(ExtMLBuffer10s,no_value); MyArrClear(ExtMColorBuffer10s,no_color);
   MyArrClear(ExtMLBuffer10m,no_value); MyArrClear(ExtMColorBuffer10m,no_color);
   MyArrClear(ExtMLBuffer10f,no_value); MyArrClear(ExtMColorBuffer10f,no_color);

   MyArrClear(ExtMLBuffer09s,no_value); MyArrClear(ExtMColorBuffer09s,no_color);
   MyArrClear(ExtMLBuffer09m,no_value); MyArrClear(ExtMColorBuffer09m,no_color);
   MyArrClear(ExtMLBuffer09f,no_value); MyArrClear(ExtMColorBuffer09f,no_color);

   MyArrClear(ExtMLBuffer08s,no_value); MyArrClear(ExtMColorBuffer08s,no_color);
   MyArrClear(ExtMLBuffer08m,no_value); MyArrClear(ExtMColorBuffer08m,no_color);
   MyArrClear(ExtMLBuffer08f,no_value); MyArrClear(ExtMColorBuffer08f,no_color);

   MyArrClear(ExtMLBuffer07s,no_value); MyArrClear(ExtMColorBuffer07s,no_color);
   MyArrClear(ExtMLBuffer07m,no_value); MyArrClear(ExtMColorBuffer07m,no_color);
   MyArrClear(ExtMLBuffer07f,no_value); MyArrClear(ExtMColorBuffer07f,no_color);

   MyArrClear(ExtMLBuffer06s,no_value); MyArrClear(ExtMColorBuffer06s,no_color);
   MyArrClear(ExtMLBuffer06m,no_value); MyArrClear(ExtMColorBuffer06m,no_color);
   MyArrClear(ExtMLBuffer06f,no_value); MyArrClear(ExtMColorBuffer06f,no_color);

   MyArrClear(ExtMLBuffer05s,no_value); MyArrClear(ExtMColorBuffer05s,no_color);
   MyArrClear(ExtMLBuffer05m,no_value); MyArrClear(ExtMColorBuffer05m,no_color);
   MyArrClear(ExtMLBuffer05f,no_value); MyArrClear(ExtMColorBuffer05f,no_color);

   MyArrClear(ExtMLBuffer04s,no_value); MyArrClear(ExtMColorBuffer04s,no_color);
   MyArrClear(ExtMLBuffer04m,no_value); MyArrClear(ExtMColorBuffer04m,no_color);
   MyArrClear(ExtMLBuffer04f,no_value); MyArrClear(ExtMColorBuffer04f,no_color);

   MyArrClear(ExtMLBuffer03s,no_value); MyArrClear(ExtMColorBuffer03s,no_color);
   MyArrClear(ExtMLBuffer03m,no_value); MyArrClear(ExtMColorBuffer03m,no_color);
   MyArrClear(ExtMLBuffer03f,no_value); MyArrClear(ExtMColorBuffer03f,no_color);

   MyArrClear(ExtMLBuffer02s,no_value); MyArrClear(ExtMColorBuffer02s,no_color);
   MyArrClear(ExtMLBuffer02m,no_value); MyArrClear(ExtMColorBuffer02m,no_color);
   MyArrClear(ExtMLBuffer02f,no_value); MyArrClear(ExtMColorBuffer02f,no_color);

   MyArrClear(ExtMLBuffer01s,no_value); MyArrClear(ExtMColorBuffer01s,no_color);
   MyArrClear(ExtMLBuffer01m,no_value); MyArrClear(ExtMColorBuffer01m,no_color);
   MyArrClear(ExtMLBuffer01f,no_value); MyArrClear(ExtMColorBuffer01f,no_color);

   MyArrClear(ExtMLBuffer00s,no_value); MyArrClear(ExtMColorBuffer00s,no_color);
   MyArrClear(ExtMLBuffer00m,no_value); MyArrClear(ExtMColorBuffer00m,no_color);
   MyArrClear(ExtMLBuffer00f,no_value); MyArrClear(ExtMColorBuffer00f,no_color);
  }
//+------------------------------------------------------------------+
void MySetBuf(int &x,int &z,
              const int shft,
              double &buf1[],
              double &buf2[],
              const int col,
              const int sty=STYLE_DOT,
              const int wid=0,
              const int icn=0,
              const string pref="",
              const double no_value=0)
  {
   SetIndexBuffer(x,buf1,INDICATOR_DATA);x++;
   SetIndexBuffer(x,buf2,INDICATOR_COLOR_INDEX); x++;

   if(pref=="")
      PlotIndexSetString(z,PLOT_LABEL,IntegerToString(shft));
   else
      PlotIndexSetString(z,PLOT_LABEL,pref);

   if(icn>32)
     {
      PlotIndexSetInteger(z,PLOT_DRAW_TYPE,DRAW_COLOR_ARROW);
      PlotIndexSetInteger(z,PLOT_ARROW,icn);
     }
   else
      PlotIndexSetInteger(z,PLOT_DRAW_TYPE,DRAW_COLOR_LINE);

   PlotIndexSetInteger(z,PLOT_LINE_STYLE,sty);
   PlotIndexSetInteger(z,PLOT_DRAW_BEGIN,0);
   PlotIndexSetInteger(z,PLOT_SHIFT,ExtShift[shft]+ExtShiftP);
   PlotIndexSetDouble(z,PLOT_EMPTY_VALUE,no_value);

   if(wid>0) PlotIndexSetInteger(z,PLOT_LINE_WIDTH,wid);
   else PlotIndexSetInteger(z,PLOT_LINE_WIDTH,1);

   MyColorsPrepare(z,col);

   z++;
  }
void MySetBufH(int &x,int &z,
               const int shft,
               double &buf1[],
               double &buf2[],
               double &buf3[],
               const int col,
               const int sty=STYLE_DOT,
               const int wid=0,
               const string pref="",
               const double no_value=0)
  {
   SetIndexBuffer(x,buf1,INDICATOR_DATA);x++;
   SetIndexBuffer(x,buf2,INDICATOR_DATA);x++;
   SetIndexBuffer(x,buf3,INDICATOR_COLOR_INDEX); x++;

   if(pref=="")
      PlotIndexSetString(z,PLOT_LABEL,IntegerToString(shft));
   else
      PlotIndexSetString(z,PLOT_LABEL,pref);

   PlotIndexSetInteger(z,PLOT_DRAW_TYPE,DRAW_COLOR_HISTOGRAM2);

   PlotIndexSetInteger(z,PLOT_LINE_STYLE,sty);
   PlotIndexSetInteger(z,PLOT_DRAW_BEGIN,0);
   PlotIndexSetInteger(z,PLOT_SHIFT,ExtShift[shft]+ExtShiftP);
   PlotIndexSetDouble(z,PLOT_EMPTY_VALUE,no_value);

   if(wid>0) PlotIndexSetInteger(z,PLOT_LINE_WIDTH,wid);
   else PlotIndexSetInteger(z,PLOT_LINE_WIDTH,1);

   MyColorsPrepare(z,col);

   z++;
  }
//+------------------------------------------------------------------+
void MyCopySMFBuffers(int cnt, int dist)
  {
   MyArrCopy(ExtMLBuffer29s,cnt,dist); MyArrCopy(ExtMColorBuffer29s,cnt,dist);
   MyArrCopy(ExtMLBuffer29m,cnt,dist); MyArrCopy(ExtMColorBuffer29m,cnt,dist);
   MyArrCopy(ExtMLBuffer29f,cnt,dist); MyArrCopy(ExtMColorBuffer29f,cnt,dist);

   MyArrCopy(ExtMLBuffer28s,cnt,dist); MyArrCopy(ExtMColorBuffer28s,cnt,dist);
   MyArrCopy(ExtMLBuffer28m,cnt,dist); MyArrCopy(ExtMColorBuffer28m,cnt,dist);
   MyArrCopy(ExtMLBuffer28f,cnt,dist); MyArrCopy(ExtMColorBuffer28f,cnt,dist);

   MyArrCopy(ExtMLBuffer27s,cnt,dist); MyArrCopy(ExtMColorBuffer27s,cnt,dist);
   MyArrCopy(ExtMLBuffer27m,cnt,dist); MyArrCopy(ExtMColorBuffer27m,cnt,dist);
   MyArrCopy(ExtMLBuffer27f,cnt,dist); MyArrCopy(ExtMColorBuffer27f,cnt,dist);

   MyArrCopy(ExtMLBuffer26s,cnt,dist); MyArrCopy(ExtMColorBuffer26s,cnt,dist);
   MyArrCopy(ExtMLBuffer26m,cnt,dist); MyArrCopy(ExtMColorBuffer26m,cnt,dist);
   MyArrCopy(ExtMLBuffer26f,cnt,dist); MyArrCopy(ExtMColorBuffer26f,cnt,dist);

   MyArrCopy(ExtMLBuffer25s,cnt,dist); MyArrCopy(ExtMColorBuffer25s,cnt,dist);
   MyArrCopy(ExtMLBuffer25m,cnt,dist); MyArrCopy(ExtMColorBuffer25m,cnt,dist);
   MyArrCopy(ExtMLBuffer25f,cnt,dist); MyArrCopy(ExtMColorBuffer25f,cnt,dist);

   MyArrCopy(ExtMLBuffer24s,cnt,dist); MyArrCopy(ExtMColorBuffer24s,cnt,dist);
   MyArrCopy(ExtMLBuffer24m,cnt,dist); MyArrCopy(ExtMColorBuffer24m,cnt,dist);
   MyArrCopy(ExtMLBuffer24f,cnt,dist); MyArrCopy(ExtMColorBuffer24f,cnt,dist);

   MyArrCopy(ExtMLBuffer23s,cnt,dist); MyArrCopy(ExtMColorBuffer23s,cnt,dist);
   MyArrCopy(ExtMLBuffer23m,cnt,dist); MyArrCopy(ExtMColorBuffer23m,cnt,dist);
   MyArrCopy(ExtMLBuffer23f,cnt,dist); MyArrCopy(ExtMColorBuffer23f,cnt,dist);

   MyArrCopy(ExtMLBuffer22s,cnt,dist); MyArrCopy(ExtMColorBuffer22s,cnt,dist);
   MyArrCopy(ExtMLBuffer22m,cnt,dist); MyArrCopy(ExtMColorBuffer22m,cnt,dist);
   MyArrCopy(ExtMLBuffer22f,cnt,dist); MyArrCopy(ExtMColorBuffer22f,cnt,dist);

   MyArrCopy(ExtMLBuffer21s,cnt,dist); MyArrCopy(ExtMColorBuffer21s,cnt,dist);
   MyArrCopy(ExtMLBuffer21m,cnt,dist); MyArrCopy(ExtMColorBuffer21m,cnt,dist);
   MyArrCopy(ExtMLBuffer21f,cnt,dist); MyArrCopy(ExtMColorBuffer21f,cnt,dist);

   MyArrCopy(ExtMLBuffer20s,cnt,dist); MyArrCopy(ExtMColorBuffer20s,cnt,dist);
   MyArrCopy(ExtMLBuffer20m,cnt,dist); MyArrCopy(ExtMColorBuffer20m,cnt,dist);
   MyArrCopy(ExtMLBuffer20f,cnt,dist); MyArrCopy(ExtMColorBuffer20f,cnt,dist);

   MyArrCopy(ExtMLBuffer19s,cnt,dist); MyArrCopy(ExtMColorBuffer19s,cnt,dist);
   MyArrCopy(ExtMLBuffer19m,cnt,dist); MyArrCopy(ExtMColorBuffer19m,cnt,dist);
   MyArrCopy(ExtMLBuffer19f,cnt,dist); MyArrCopy(ExtMColorBuffer19f,cnt,dist);

   MyArrCopy(ExtMLBuffer18s,cnt,dist); MyArrCopy(ExtMColorBuffer18s,cnt,dist);
   MyArrCopy(ExtMLBuffer18m,cnt,dist); MyArrCopy(ExtMColorBuffer18m,cnt,dist);
   MyArrCopy(ExtMLBuffer18f,cnt,dist); MyArrCopy(ExtMColorBuffer18f,cnt,dist);

   MyArrCopy(ExtMLBuffer17s,cnt,dist); MyArrCopy(ExtMColorBuffer17s,cnt,dist);
   MyArrCopy(ExtMLBuffer17m,cnt,dist); MyArrCopy(ExtMColorBuffer17m,cnt,dist);
   MyArrCopy(ExtMLBuffer17f,cnt,dist); MyArrCopy(ExtMColorBuffer17f,cnt,dist);

   MyArrCopy(ExtMLBuffer16s,cnt,dist); MyArrCopy(ExtMColorBuffer16s,cnt,dist);
   MyArrCopy(ExtMLBuffer16m,cnt,dist); MyArrCopy(ExtMColorBuffer16m,cnt,dist);
   MyArrCopy(ExtMLBuffer16f,cnt,dist); MyArrCopy(ExtMColorBuffer16f,cnt,dist);

   MyArrCopy(ExtMLBuffer15s,cnt,dist); MyArrCopy(ExtMColorBuffer15s,cnt,dist);
   MyArrCopy(ExtMLBuffer15m,cnt,dist); MyArrCopy(ExtMColorBuffer15m,cnt,dist);
   MyArrCopy(ExtMLBuffer15f,cnt,dist); MyArrCopy(ExtMColorBuffer15f,cnt,dist);

   MyArrCopy(ExtMLBuffer14s,cnt,dist); MyArrCopy(ExtMColorBuffer14s,cnt,dist);
   MyArrCopy(ExtMLBuffer14m,cnt,dist); MyArrCopy(ExtMColorBuffer14m,cnt,dist);
   MyArrCopy(ExtMLBuffer14f,cnt,dist); MyArrCopy(ExtMColorBuffer14f,cnt,dist);

   MyArrCopy(ExtMLBuffer13s,cnt,dist); MyArrCopy(ExtMColorBuffer13s,cnt,dist);
   MyArrCopy(ExtMLBuffer13m,cnt,dist); MyArrCopy(ExtMColorBuffer13m,cnt,dist);
   MyArrCopy(ExtMLBuffer13f,cnt,dist); MyArrCopy(ExtMColorBuffer13f,cnt,dist);

   MyArrCopy(ExtMLBuffer12s,cnt,dist); MyArrCopy(ExtMColorBuffer12s,cnt,dist);
   MyArrCopy(ExtMLBuffer12m,cnt,dist); MyArrCopy(ExtMColorBuffer12m,cnt,dist);
   MyArrCopy(ExtMLBuffer12f,cnt,dist); MyArrCopy(ExtMColorBuffer12f,cnt,dist);

   MyArrCopy(ExtMLBuffer11s,cnt,dist); MyArrCopy(ExtMColorBuffer11s,cnt,dist);
   MyArrCopy(ExtMLBuffer11m,cnt,dist); MyArrCopy(ExtMColorBuffer11m,cnt,dist);
   MyArrCopy(ExtMLBuffer11f,cnt,dist); MyArrCopy(ExtMColorBuffer11f,cnt,dist);

   MyArrCopy(ExtMLBuffer10s,cnt,dist); MyArrCopy(ExtMColorBuffer10s,cnt,dist);
   MyArrCopy(ExtMLBuffer10m,cnt,dist); MyArrCopy(ExtMColorBuffer10m,cnt,dist);
   MyArrCopy(ExtMLBuffer10f,cnt,dist); MyArrCopy(ExtMColorBuffer10f,cnt,dist);

   MyArrCopy(ExtMLBuffer09s,cnt,dist); MyArrCopy(ExtMColorBuffer09s,cnt,dist);
   MyArrCopy(ExtMLBuffer09m,cnt,dist); MyArrCopy(ExtMColorBuffer09m,cnt,dist);
   MyArrCopy(ExtMLBuffer09f,cnt,dist); MyArrCopy(ExtMColorBuffer09f,cnt,dist);

   MyArrCopy(ExtMLBuffer08s,cnt,dist); MyArrCopy(ExtMColorBuffer08s,cnt,dist);
   MyArrCopy(ExtMLBuffer08m,cnt,dist); MyArrCopy(ExtMColorBuffer08m,cnt,dist);
   MyArrCopy(ExtMLBuffer08f,cnt,dist); MyArrCopy(ExtMColorBuffer08f,cnt,dist);

   MyArrCopy(ExtMLBuffer07s,cnt,dist); MyArrCopy(ExtMColorBuffer07s,cnt,dist);
   MyArrCopy(ExtMLBuffer07m,cnt,dist); MyArrCopy(ExtMColorBuffer07m,cnt,dist);
   MyArrCopy(ExtMLBuffer07f,cnt,dist); MyArrCopy(ExtMColorBuffer07f,cnt,dist);

   MyArrCopy(ExtMLBuffer06s,cnt,dist); MyArrCopy(ExtMColorBuffer06s,cnt,dist);
   MyArrCopy(ExtMLBuffer06m,cnt,dist); MyArrCopy(ExtMColorBuffer06m,cnt,dist);
   MyArrCopy(ExtMLBuffer06f,cnt,dist); MyArrCopy(ExtMColorBuffer06f,cnt,dist);

   MyArrCopy(ExtMLBuffer05s,cnt,dist); MyArrCopy(ExtMColorBuffer05s,cnt,dist);
   MyArrCopy(ExtMLBuffer05m,cnt,dist); MyArrCopy(ExtMColorBuffer05m,cnt,dist);
   MyArrCopy(ExtMLBuffer05f,cnt,dist); MyArrCopy(ExtMColorBuffer05f,cnt,dist);

   MyArrCopy(ExtMLBuffer04s,cnt,dist); MyArrCopy(ExtMColorBuffer04s,cnt,dist);
   MyArrCopy(ExtMLBuffer04m,cnt,dist); MyArrCopy(ExtMColorBuffer04m,cnt,dist);
   MyArrCopy(ExtMLBuffer04f,cnt,dist); MyArrCopy(ExtMColorBuffer04f,cnt,dist);

   MyArrCopy(ExtMLBuffer03s,cnt,dist); MyArrCopy(ExtMColorBuffer03s,cnt,dist);
   MyArrCopy(ExtMLBuffer03m,cnt,dist); MyArrCopy(ExtMColorBuffer03m,cnt,dist);
   MyArrCopy(ExtMLBuffer03f,cnt,dist); MyArrCopy(ExtMColorBuffer03f,cnt,dist);

   MyArrCopy(ExtMLBuffer02s,cnt,dist); MyArrCopy(ExtMColorBuffer02s,cnt,dist);
   MyArrCopy(ExtMLBuffer02m,cnt,dist); MyArrCopy(ExtMColorBuffer02m,cnt,dist);
   MyArrCopy(ExtMLBuffer02f,cnt,dist); MyArrCopy(ExtMColorBuffer02f,cnt,dist);

   MyArrCopy(ExtMLBuffer01s,cnt,dist); MyArrCopy(ExtMColorBuffer01s,cnt,dist);
   MyArrCopy(ExtMLBuffer01m,cnt,dist); MyArrCopy(ExtMColorBuffer01m,cnt,dist);
   MyArrCopy(ExtMLBuffer01f,cnt,dist); MyArrCopy(ExtMColorBuffer01f,cnt,dist);

   MyArrCopy(ExtMLBuffer00s,cnt,dist); MyArrCopy(ExtMColorBuffer00s,cnt,dist);
   MyArrCopy(ExtMLBuffer00m,cnt,dist); MyArrCopy(ExtMColorBuffer00m,cnt,dist);
   MyArrCopy(ExtMLBuffer00f,cnt,dist); MyArrCopy(ExtMColorBuffer00f,cnt,dist);
  }
//+------------------------------------------------------------------+
